<?php

class paypay extends base {

  function __construct() {
  }

  static function getPaymentLayout($order_id)
  {
      global $db;
      $query = "SELECT payment_type FROM paypay_payment_type WHERE id_order = :order_id";
      $query = $db->bindVars($query, ":order_id", $order_id, "integer");
      $payment_type = $db->Execute($query);

      if ($payment_type->fields['payment_type'] == "1") {
          return self::getReferenceLayout($order_id);
      } elseif ($payment_type->fields['payment_type'] == "2" || $payment_type->fields['payment_type'] == "3") {
          return self::getCreditCardLayout($order_id);
      } else {
          return false;
      }
  }

  static function getReferenceLayout($order_id)
  {
      global $db, $currencies;
      $query = "SELECT * FROM paypay_reference WHERE id_order = :order_id";
      $query = $db->bindVars($query, ":order_id", $order_id, "integer");
      $payment = $db->Execute($query);
      require_once(zen_get_file_directory(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/payment/','paypay_mb.php', 'false'));

      if ($payment->fields['paid'] === '0') {
          $payment->fields['refMB'] = substr($payment->fields['refMB'], 0, 3) . ' ' . substr($payment->fields['refMB'], 3, 3) . ' ' . substr($payment->fields['refMB'], 6, 3);

          $comment  = '<table style="width: 90%; font-weight: normal;">';
          $comment .= "<tr><td style=\"padding: 15px 0 0 0;\">".MODULE_PAYMENT_PAYPAY_MB_INFO_TO_PAY."</td></tr>";
          $comment .= '</table>';
          $comment .= '<table cellpadding="3" cellspacing="0" style="width: 180px; font-weight: normal; padding: 5px 0 0 0;">';
          $comment .= "	<tr>";
          $comment .= '		<td style="text-align:left; padding: 15px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_MB_ENTITY.'</td>';
          $comment .= '		<td style="font-weight:bold; padding-left: 5px; text-align:right; padding: 15px 0 0 0;">'.$payment->fields['entity'].'</td>';
          $comment .= "	</tr>";
          $comment .= "	<tr>";
          $comment .= '	    <td style="text-align:left; padding: 5px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_MB_REFERENCE.'</td>';
          $comment .= '		<td style="font-weight:bold; padding-left: 5px; text-align:right; padding: 5px 0 0 0;">'.$payment->fields['refMB' ].'</td>';
          $comment .= "	</tr>";
          $comment .= "	<tr>";
          $comment .= '		<td style="text-align:left; padding: 5px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_MB_VALUE.'</td>';
          $comment .= '		<td style="font-weight:bold; padding-left: 5px; text-align:right; padding: 5px 0 0 0;">'.$currencies->format($payment->fields['amount'], false, 'EUR').'</td>';
          $comment .= "	</tr>";
          $comment .= "</table>";
          $comment .= "<style>#myAccountPaymentInfo > div {font-weight: bold;}</style>";
      } elseif ($payment->fields['paid'] === '1') {
          $comment .= '<table cellpadding="3" cellspacing="0" style="font-weight: normal;">';
          $comment .= '<tr><td style="padding: 15px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_MB_SUCCESS.'</td></tr>';
          $comment .= '</table>';
          $comment .= "<style>#myAccountPaymentInfo > div {font-weight: bold;}</style>";
      } else {
          $comment .= '<table cellpadding="3" cellspacing="0" style="font-weight: normal;">';
          $comment .= '<tr><td style="padding: 15px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_MB_CANCELLED.'</td></tr>';
          $comment .= '</table>';
          $comment .= "<style>#myAccountPaymentInfo > div {font-weight: bold;}</style>";
      }

      return $comment;
  }

  static function getCreditCardLayout($order_id) {
      global $db;
      $query = "SELECT * FROM paypay_payment WHERE id_order = :order_id";
      $query = $db->bindVars($query, ":order_id", $order_id, "integer");
      $payment = $db->Execute($query);

      require_once(zen_get_file_directory(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/payment/','paypay_cc.php', 'false'));

      if ($payment->fields['paid'] === '0') {
          $comment .= '<table cellpadding="3" cellspacing="0" style="font-weight: normal;">';
          $comment .= '<tr><td style="padding: 15px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_CC_CLICK.' <a href="'.$payment->fields['url'].'">'.MODULE_PAYMENT_PAYPAY_CC_HERE.'</a> '.MODULE_PAYMENT_PAYPAY_CC_TO_PAY.'</td></tr>';
          $comment .= '</table>';
          $comment .= "<style>#myAccountPaymentInfo > div {font-weight: bold;}</style>";
      } elseif ($payment->fields['paid'] === '1') {
          $comment .= '<table cellpadding="3" cellspacing="0" style="font-weight: normal;">';
          $comment .= '<tr><td style="padding: 15px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_CC_SUCCESS.'</td></tr>';
          $comment .= '</table>';
          $comment .= "<style>#myAccountPaymentInfo > div {font-weight: bold;}</style>";
      } else {
          $comment .= '<table cellpadding="3" cellspacing="0" style="font-weight: normal;">';
          $comment .= '<tr><td style="padding: 15px 0 0 0;">'.MODULE_PAYMENT_PAYPAY_CC_CANCELLED.'</td></tr>';
          $comment .= '</table>';
          $comment .= "<style>#myAccountPaymentInfo > div {font-weight: bold;}</style>";
      }

      return $comment;
  }
}
