<?php
global $db;

$confirmation_hash_mb = hash('sha256', MODULE_PAYMENT_PAYPAY_MB_HASH.$_POST['hookAction'].$_POST['hookDate']);
$confirmation_hash_cc = hash('sha256', MODULE_PAYMENT_PAYPAY_CC_HASH.$_POST['hookAction'].$_POST['hookDate']);
$confirmation_hash_mw = hash('sha256', MODULE_PAYMENT_PAYPAY_MW_HASH . $_POST['hookAction'] . $_POST['hookDate']);

if ($_POST['hookHash'] != $confirmation_hash_mb && $_POST['hookHash'] != $confirmation_hash_cc) {
    header('HTTP/1.1 500 Internal Server Error');
    die();
}

foreach ($_POST['payments'] as $payment) {
    if ($payment['paymentMethodCode'] == "MB") {
        $query    = "SELECT id_order, paid FROM paypay_reference WHERE id_transaction = :id_transaction";
        $query    = $db->bindVars($query, ":id_transaction", $payment['paymentId'], "integer");
        $res      = $db->Execute($query);
        $order_id = $res->fields['id_order'];
        if ($res->fields['paid'] == "0") {
            $query = "UPDATE paypay_reference SET paid = '1' WHERE id_order = :order_id";
            $query = $db->bindVars($query, ":order_id", $order_id, "integer");
            $db->Execute($query);
        }
    } elseif ($payment['paymentMethodCode'] == "CC" || $payment['paymentMethodCode'] == "MW") {
        $query    = "SELECT id_order, paid FROM paypay_payment WHERE id_transaction = :id_transaction";
        $query    = $db->bindVars($query, ":id_transaction", $payment['paymentId'], "integer");
        $res      = $db->Execute($query);
        $order_id = $res->fields['id_order'];
        if ($res->fields['paid'] == "0") {
            $query = "UPDATE paypay_payment SET paid = '1' WHERE id_order = :order_id";
            $query = $db->bindVars($query, ":order_id", $order_id, "integer");
            $db->Execute($query);
        }
    }

    if ($res->fields['paid'] == "0") {
        $query = "UPDATE orders SET orders_status = '2' WHERE orders_id = :order_id";
        $query = $db->bindVars($query, ":order_id", $order_id, "integer");
        $db->Execute($query);
        $query = "INSERT INTO orders_status_history VALUES (DEFAULT, :order_id, '2', CURRENT_TIMESTAMP, '1', :payment_date)";
        $query = $db->bindVars($query, ":order_id", $order_id, "integer");
        $query = $db->bindVars($query, ":payment_date", "Data de Pagamento: ".$payment['paymentDate'], "string");
        $db->Execute($query);
    }
}

header('HTTP/1.1 200 OK');
die();
