<?php

class paypay_cc extends base {
    var $code, $title, $description, $enabled, $pag;
    const MULTIBANCO       = 1;
    const CREDIT_CARD      = 2;

    function paypay_cc() {
        global $order, $customer_id, $insert_id;
        $this->code             = 'paypay_cc';
        $this->title            = MODULE_PAYMENT_PAYPAY_CC_CREDIT_CARD_TYPE;
        $this->description      = MODULE_PAYMENT_PAYPAY_CC_CREDIT_CARD_DESCRIPTION;
        $this->hash             = MODULE_PAYMENT_PAYPAY_CC_HASH;
        $this->nif              = MODULE_PAYMENT_PAYPAY_CC_NIF;
        $this->platform_code    = MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE;
        $this->environment      = MODULE_PAYMENT_PAYPAY_CC_ENVIRONMENT;
        $this->sort_order       = MODULE_PAYMENT_PAYPAY_CC_SORT_ORDER;
        $this->enabled          = ((MODULE_PAYMENT_PAYPAY_CC_STATUS == 'Sim') ? true : false);

        if ($this->hash == "MODULE_PAYMENT_PAYPAY_CC_HASH" || empty($this->hash)
            || $this->nif == "MODULE_PAYMENT_PAYPAY_CC_NIF" || empty($this->nif)
            || $this->platform_code == "MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE" || empty($this->platform_code)) {
            $this->title .=  '<span class="alert"> (Not Configured Correctly)</span>';
            $this->enabled = false;
        }

        if (!empty(MODULE_PAYMENT_PAYPAY_CC_ENVIRONMENT) && MODULE_PAYMENT_PAYPAY_CC_ENVIRONMENT === "Teste") {
            $this->server_url   = "https://paypay.acin.pt/paypaybeta/index.php/paypayservices/paypayservices_c/server";
            $this->wsdl_url     = "https://paypay.acin.pt/paypaybeta/index.php/paypayservices/paypayservices_c/wsdl";
        } else {
            $this->server_url   = "https://paypay.pt/paypay/index.php/paypayservices/paypayservices_c/server";
            $this->wsdl_url     = "https://paypay.pt/paypay/index.php/paypayservices/paypayservices_c/wsdl";
        }

        $this->checkWebHook();

        if (defined("MODULE_PAYMENT_PAYPAY_CC_NIF") && (!isset($_SESSION['verify_payments']) || $_SESSION['verify_payments'] !== false)) {
            $this->checkPayments();
        }

        if (is_object($order)) $this->update_status();
    }

    function update_status() {
        global $order, $db;

        if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYPAY_CC_ZONE > 0) ) {
            $check_flag = false;
            $check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYPAY_CC_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
            while (!$check_query->EOF) {
                if ($check_query->fields['zone_id'] < 1) {
                    $check_flag = true;
                    break;
                } elseif ($check_query->fields['zone_id'] == $order->billing['zone_id']) {
                    $check_flag = true;
                    break;
                }
                $check_query->MoveNext();
            }

            if ($check_flag == false) {
                $this->enabled = false;
            }
        }
    }

    function javascript_validation() {
        return false;
    }

    function selection() {
        return array('id' => $this->code,
                     'module' => $this->title);
    }

    function pre_confirmation_check() {
        return false;
    }

    function confirmation() {
        return false;
    }

    function process_button() {
        return false;
    }
    
    function after_order_create($insert_id){
        global $db, $order, $orderpaypayCC;
        $payment = $this->generatePayment($insert_id,$order->info['total']);
        $this->email_footer = $this->getEmailPaymentLayout($payment);
        $orderpaypayCC = $payment;
        $this->attach($this, array('NOTIFY_HEADER_END_CHECKOUT_PROCESS'));
        return false;
    }

    function update(&$class, $eventID, $paramsArray = array())
    {
        global $orderpaypayCC;
        
        if ($eventID == 'NOTIFY_HEADER_END_CHECKOUT_PROCESS')
        {
            zen_redirect($orderpaypayCC['url']);
        }
    }

    function before_process() {

        return false;
    }

    function after_process() {
        return false;
    }

    function get_error() {
        return false;
    }

    function check() {
       global $db;
       if (!isset($this->_check)) {
           $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYPAY_CC_STATUS'");
           $this->_check = $check_query->RecordCount();
       }
       return $this->_check;
    }

    function install() {
        global $db;
	    $db->Execute("CREATE TABLE IF NOT EXISTS `paypay_payment_type` (id_order int, payment_type tinyint(2))");
	    $db->Execute("CREATE TABLE IF NOT EXISTS `paypay_reference` (id_order int, refMB VARCHAR(9), entity VARCHAR(5), amount DECIMAL(15, 2), id_transaction INT(11), paid TINYINT(1) NOT NULL DEFAULT '0')");
	    $db->Execute("CREATE TABLE IF NOT EXISTS `paypay_payment` (id_order int, id_transaction INT(11), redunicre_token VARCHAR(100), url VARCHAR(300), history_id INT(11), paid TINYINT(1) NOT NULL DEFAULT '0')");
	    $db->Execute("CREATE TABLE IF NOT EXISTS `paypay_config` (id int NOT NULL AUTO_INCREMENT, hooked tinyint(2), action VARCHAR(100), url VARCHAR(500), nif VARCHAR(9), PRIMARY KEY (id))");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('NIF', 'MODULE_PAYMENT_PAYPAY_CC_NIF', '', 'NIF registado na plataforma PayPay', '6', '1', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Hash', 'MODULE_PAYMENT_PAYPAY_CC_HASH', '', 'Hash fornecida pela plataforma PayPay', '6', '2', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Código de Plataforma', 'MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE', '', 'Código de Plataforma fornecedido pela plataforma PayPay', '6', '3', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Ambiente', 'MODULE_PAYMENT_PAYPAY_CC_ENVIRONMENT', 'Teste', 'Ambiente de em que se encontra neste momento', '6', '5', 'zen_cfg_select_option(array(\'Teste\', \'Produção\'), ', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Activar o módulo Pagamento', 'MODULE_PAYMENT_PAYPAY_CC_STATUS', 'Sim', 'Para utilizar este método de pagamento selecione \"Sim\"', '6', '6', 'zen_cfg_select_option(array(\'Sim\', \'Não\'), ', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Ordem de exibição.', 'MODULE_PAYMENT_PAYPAY_CC_SORT_ORDER', '0', 'Ordem em que este método de pagamento deve ser apresentado', '6', '7', now())");
    }

    function remove() {
        global $db;
        $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
        $db->Execute("delete from paypay_config");
    }

    function keys() {
        return array('MODULE_PAYMENT_PAYPAY_CC_SORT_ORDER',
            'MODULE_PAYMENT_PAYPAY_CC_STATUS',
            'MODULE_PAYMENT_PAYPAY_CC_HASH',
            'MODULE_PAYMENT_PAYPAY_CC_NIF',
            'MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE',
            'MODULE_PAYMENT_PAYPAY_CC_ENVIRONMENT'
        );
    }

    function generatePayment($order_id, $total) {
        require_once __DIR__.'/structures/RequestEntity.php';
        require_once __DIR__.'/structures/RequestCreditCardPayment.php';
        require_once __DIR__.'/structures/RequestPaymentOrder.php';
        require_once __DIR__.'/structures/ResponseIntegrationState.php';

        $classmap = array(
            'RequestEntity'            => 'RequestEntity',
            'RequestCreditCardPayment' => 'RequestCreditCardPayment',
            'RequestPaymentOrder'      => 'RequestPaymentOrder',
            'ResponseIntegrationState' => 'ResponseIntegrationState'
        );

        $options = array (
            'classmap'  => $classmap,
            'location'  => $this->server_url,
        );

        $paymentWebservice = new SoapClient($this->wsdl_url, $options);

        $date = new DateTime();
        $date->modify("+1 minutes");
        $date->modify("+1 hour");
        $dataAtual  = $date->format("d-m-Y H:i:s");
        $amount     = number_format($total, 2, '', '');

        $hash = hash('sha256', MODULE_PAYMENT_PAYPAY_CC_HASH.$dataAtual);
        $requestEntity = new RequestEntity(
            MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE,
            $hash,
            $dataAtual,
            MODULE_PAYMENT_PAYPAY_CC_NIF,
            $_SESSION['languages_code']
        );

        $order = new RequestPaymentOrder(
            array(
                'amount' => $amount,
                'productCode' => $order_id
            )
        );

        $requestCreditCardPayment = new RequestCreditCardPayment(
            $order,
            zen_href_link("paypay_success"),
            html_entity_decode(zen_href_link("paypay_failure", "order_id=" . $order_id)),
            html_entity_decode(zen_href_link("account_history_info", "order_id=" . $order_id)),
            "",
            "CC"
        );

        try {
            $response = $paymentWebservice->doWebPayment($requestEntity, $requestCreditCardPayment);
        } catch (Exception $e) {
            echo "<script>alert('".$e->getMessage()."');</script>";
            return $e->getCode();
        }

        if ($response->requestState->state != "1") {
            echo "<script>alert('PayPay integration error.');</script>";
        }

        if (empty($response)) {
            $payment = array(
                'url'           => "",
                'idTransaction' => "",
                'token'         => "",
                'paid'          => "2"
            );
        } else {
            $payment = array(
                'url'           => $response->url,
                'idTransaction' => $response->idTransaction,
                'token'         => $response->token,
                'paid'          => "0"
            );
        }

        $this->saveCC($order_id, $payment);

        return $payment;
    }

    function saveCC($order_id, $payment) {
        global $db;
        $query = "INSERT INTO paypay_payment_type VALUES ('".$order_id."', '".self::CREDIT_CARD."')";
        $db->Execute($query);
        $query = "INSERT INTO paypay_payment VALUES ('".$order_id."', '".$payment['idTransaction']."', '".$payment['token']."', '".$payment['url']."', '0', '".$payment['paid']."')";
        return $db->Execute($query);
    }

    function sendPaymentEmail($payment, $customer) {
        zen_mail($customer['firstname'].' '.$customer['lastname'], $customer['email_address'], STORE_NAME." - Dados de pagamento", $this->getEmailPaymentLayout($order_id, $payment), STORE_NAME, EMAIL_FROM, array(), 'paypay_cc');
    }

    function checkWebHook() {
        global $db;

        if (defined("MODULE_PAYMENT_PAYPAY_CC_NIF") && !empty(MODULE_PAYMENT_PAYPAY_CC_NIF)) {
            $query  = "SELECT id FROM paypay_config WHERE nif='".MODULE_PAYMENT_PAYPAY_CC_NIF."'";
            $config = $db->Execute($query);
            if ($config->resource->num_rows == 0) {
                if ($this->subscribeToWebhook() === -1) {
                    $this->title  .=  '<span class="alert"> (Not Configured Correctly)</span>';
                    $this->enabled = false;
                }
            }
            return true;
        } else {
            return false;
        }
    }

    function subscribeToWebhook() {
        global $db;

        require_once __DIR__.'/structures/RequestEntity.php';
        require_once __DIR__.'/structures/ResponseIntegrationState.php';
        require_once __DIR__.'/structures/RequestWebhook.php';
        require_once __DIR__.'/structures/ResponseWebhook.php';

        $classmap = array(
            'RequestEntity'            => 'RequestEntity',
            'ResponseIntegrationState' => 'ResponseIntegrationState',
            'RequestWebhook'           => 'RequestWebhook',
            'ResponseWebhook'          => 'ResponseWebhook'
        );

        $options = array (
            'classmap'  => $classmap,
            'location'  => $this->server_url,
        );

        $paymentWebservice = new SoapClient($this->wsdl_url, $options);

        $date = new DateTime();
        $date->modify("+1 minutes");
        $date->modify("+1 hour");
        $dataAtual = $date->format("d-m-Y H:i:s");

        $hash = hash('sha256', MODULE_PAYMENT_PAYPAY_CC_HASH.$dataAtual);
        $requestEntity = new RequestEntity(
            MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE,
            $hash,
            $dataAtual,
            MODULE_PAYMENT_PAYPAY_CC_NIF,
            $_SESSION['languages_code']
        );

        $url = zen_catalog_href_link("paypay_callback", "", "SSL");

        $requestWebhook = new RequestWebhook(
            array(
                'action' => 'payment_confirmed',
                'url'    => $url
            )
        );

        try {
            $response = $paymentWebservice->subscribeToWebhook($requestEntity, $requestWebhook);
        } catch (Exception $e) {
            echo "<script>alert(PayPay: '".$e->getMessage()."');</script>";
            return false;
        }

        if ($response->integrationState->state == "1") {
            $query   = "INSERT INTO paypay_config VALUES(DEFAULT, 1, 'payment_confirmed', '".$url."', '".MODULE_PAYMENT_PAYPAY_CC_NIF."')";
            $db->Execute($query);
            return $response;
        } else {
            return -1;
        }
    }

    function checkPayments()
    {
        require_once __DIR__.'/structures/RequestEntity.php';
        require_once __DIR__.'/structures/RequestEntityPayments.php';
        require_once __DIR__.'/structures/RequestPaymentDetails.php';
        require_once __DIR__.'/structures/RequestReferenceDetails.php';
        require_once __DIR__.'/structures/ResponseEntityPayments.php';
        require_once __DIR__.'/structures/ResponseIntegrationState.php';
        require_once __DIR__.'/structures/PaymentDetails.php';
        $this->checkMBPayments();
        $this->checkMWandCCPayments();
        $_SESSION['verify_payments'] = false;
    }

    function checkMBPayments()
    {
        global $db;

        $classmap = array(
            'RequestEntity'                 => 'RequestEntity',
            'RequestEntityPayments'         => 'RequestEntityPayments',
            'RequestReferenceDetails'       => 'RequestReferenceDetails',
            'ResponseEntityPayments'        => 'ResponseEntityPayments',
            'ResponseIntegrationState'      => 'ResponseIntegrationState',
            'PaymentDetails'                => 'PaymentDetails'
        );

        $options = array (
            'classmap'  => $classmap,
            'location'  => $this->server_url,
        );

        $paymentWebservice = new SoapClient($this->wsdl_url, $options);

        $date = new DateTime();
        $date->modify("+1 minutes");
        $date->modify("+1 hour");
        $dataAtual = $date->format("d-m-Y H:i:s");

        $hash = hash('sha256', MODULE_PAYMENT_PAYPAY_CC_HASH.$dataAtual);
        $requestEntity = new RequestEntity(
            MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE,
            $hash,
            $dataAtual,
            MODULE_PAYMENT_PAYPAY_CC_NIF,
            $_SESSION['languages_code']
        );

        $query = "SELECT refMB, id_order FROM paypay_reference WHERE paid = '0'";
        $pending_mb_payments = $db->Execute($query);

        $pending_payments_data = array();
        while (!$pending_mb_payments->EOF) {
            $payment_order_data[] = $pending_mb_payments->fields['id_order'];
            $data['reference']    = $pending_mb_payments->fields['refMB'];
            $requestReferenceDetails = new RequestReferenceDetails($data);
            $payments[] = $requestReferenceDetails;
            $pending_mb_payments->MoveNext();
        }

        $requestEntityPayments = new RequestEntityPayments();
        $requestEntityPayments->payments = $payments;

        try {
            $response = $paymentWebservice->checkEntityPayments($requestEntity, $requestEntityPayments);
        } catch (Exception $e) {
            return $e->getCode();
        }

        if ($response->state->state == "1") {
            foreach ($response->payments as $index => $payment) {
                if ($payment->paymentState === 1) {
                    $order_id = $payment_order_data[$index];
                    $query = "UPDATE paypay_reference SET paid = '1' WHERE id_order='".$order_id."'";
                    $db->Execute($query);
                    $query = "INSERT INTO orders_status_history VALUES (DEFAULT, '".$order_id."', '2', NOW(), '1', '')";
                    $db->Execute($query);
                }
            }
            return true;
        } else {
            return false;
        }
    }

    public function checkMWandCCPayments()
    {
        global $db;

        $classmap = array(
            'RequestEntity'                 => 'RequestEntity',
            'RequestPaymentDetails'         => 'RequestPaymentDetails',
            'ResponseIntegrationState'      => 'ResponseIntegrationState'
        );

        $options = array (
            'classmap'  => $classmap,
            'location'  => $this->server_url,
        );

        $paymentWebservice = new SoapClient($this->wsdl_url, $options);

        $date = new DateTime();
        $date->modify("+1 minutes");
        $date->modify("+1 hour");
        $dataAtual = $date->format("d-m-Y H:i:s");

        $hash = hash('sha256', MODULE_PAYMENT_PAYPAY_CC_HASH.$dataAtual);
        $requestEntity = new RequestEntity(
            MODULE_PAYMENT_PAYPAY_CC_PLATFORM_CODE,
            $hash,
            $dataAtual,
            MODULE_PAYMENT_PAYPAY_CC_NIF,
            $_SESSION['languages_code']
        );

        $query = "SELECT redunicre_token, id_transaction, id_order FROM paypay_payment WHERE paid = '0'";
        $pending_cc_payments = $db->Execute($query);

        $pending_payments_data = array();
        while (!$pending_cc_payments->EOF) {
            $requestPaymentDetails = new RequestPaymentDetails($pending_cc_payments->fields['redunicre_token'], $pending_cc_payments->fields['id_transaction']);

            try {
                $response = $paymentWebservice->checkWebPayment($requestEntity, $requestPaymentDetails);
            } catch (Exception $e) {
                return $e->getCode();
            }

            if ($response->requestState->state == "1") {
                if ($response->paid === 1) {
                    $order_id = $pending_cc_payments->fields['id_order'];
                    $query = "UPDATE paypay_payment SET paid = '1' WHERE id_order='".$order_id."'";
                    $result = $db->Execute($query);
                    if (mysqli_affected_rows($db->link) > 0) {
                        $query = "INSERT INTO orders_status_history
                                  VALUES (DEFAULT, '".$order_id."', '2', NOW(), '1', '')";
                        $db->Execute($query);
                    }
                }
            }

            $pending_cc_payments->MoveNext();
        }

        return true;
    }

    function getEmailPaymentLayout($payment) {
        $content .= MODULE_PAYMENT_PAYPAY_CC_FOOTER_TITLE_TIPO_PAGO;
        $content .= $payment['url'];

        return $content;
    }
}

?>
